/**
 * Created by petry_000 on 07.05.2017.
 */
angular.module('Qfe7').service("Agent", function () {

    function AgentBuilder0() {
        const a = this;

        const colors = [
            '#e7c1b2',
            '#e7cbb5',
            '#e8b894',
            '#c28155',
            '#7b4934'
        ];

        const defaultAgent = {
            type: 'male',
            age: 'mature',
            skin: colors[Math.round(4 * Math.random())],
            supplies: []
        };

        a.agent = {
            _id: UUID.generate().toUpperCase(),
            name: new DockerNames().getRandomName(),
            type: undefined,
            age: undefined,
            skin: undefined,
            supplies: [],
            links: []
        };

        _.extend(a.agent, defaultAgent);

        function setter(prop, value, custom) {
            a[value] = function () {
                a.agent[prop] = value;
                if (custom) custom();
                return a;
            }
        }

        setter('type', 'male');
        setter('type', 'female');
        setter('type', 'organization', () => {
            a.agent.skin = '#cecece';
            a.agent.age = 'monster';
        });
        setter('age', 'child');
        setter('age', 'mature');
        setter('age', 'monster');

        a.has = function (supply) {
            a.agent.supplies.push(supply);
            return a;
        };

        a.build = function () {
            if (!_.isEqual(a.agent.type, 'organization')) {
                a.has('inner-energy');
                a.has('food');
            }
            return a.agent;
        }
    }

    this.is = function () {
        return new AgentBuilder0();
    }
}).service("Link", function () {

    function LinkBuilder0(from) {
        const l = this;

        var to = from;

        l.link = {
            _id: UUID.generate().toUpperCase(),
            from: {
                id: from._id,
                supply: undefined
            },
            measure: undefined,
            value: undefined,
            to: {
                id: to._id,
                supply: undefined
            },
        };

        l.to = function (t) {
            to = t;
            l.link.to.id = t._id;
            return l;
        };

        l.eat = function () {
            from._id.should.eql(to._id);
            _.extend(l.link, {
                type: 'eat',
                measure: 'kg/day',
                value: 1,
                to: {id: to._id, supply: 'inner-energy'},
                from: {id: from._id, supply: 'food'}
            });
            return l;
        };

        l.life = function () {
            from._id.should.eql(to._id);
            _.extend(l.link, {
                type: 'life',
                measure: 'kkal/day',
                value: 2500,
                to: {id: to._id, supply: 'power'},
                from: {id: from._id, supply: 'inner-energy'}
            });
            return l;
        };

        l.food = function (v) {
            _.extend(l.link, {
                type: 'food',
                measure: 'kg/day',
                value: v,
                to: {id: to._id, supply: 'food'},
                from: {id: from._id, supply: 'food'}
            });
            return l;
        };

        l.build = function () {
            if (_.findIndex(from.supplies, s => l.link.from.supply) < 0)
                throw new Error("no supply from");
            if (_.findIndex(to.supplies, s => l.link.to.supply) < 0)
                throw new Error("no supply to");

            from.links.push(l.link);
            return l.link;
        }
    }

    this.for = function (a) {
        return new LinkBuilder0(a);
    }
});